---
import type {CollectionEntry} from 'astro:content';
import BaseHead from '../components/BaseHead.astro';
import FormattedDate from '../components/FormattedDate.astro';
import BaseLayout from "./BaseLayout.astro";
import {getCollection} from "astro:content";
import FormattedTime from "../components/FormattedTime.astro";

type Props = CollectionEntry<'konzert'>['data'];

const {
  title,
  description,
  date,
  heroImage,
  endDate,
  gruppe_ref,
  musiker_ref,
  location,
  locationUrl,
  locationImage,
  price,
  priceDescription,
  programm,
  goody,
  veranstalter,
  sponsoren,
  related_blog_ref,
  abgesagt,
  verschoben
} = Astro.props;

const gruppen = (await getCollection('konzert_gruppe'));
const gruppe = gruppen.find((g) => g.id === gruppe_ref);

// Mit zwei Stellen nach dem Komma ausgeben & ins deutsche Format bringen
const readablePrice = price ? price.toString().replace('.', ',') : undefined;

const relatedBlog = (await getCollection('blog')).find((blog) =>  blog?.slug === related_blog_ref);

---

<html lang="de">
<head>
  <BaseHead title={title} description={description}/>
  <style>
    .timebox-wrapper {
      display: flex;
      gap: 1rem;
    }

    .timebox-wrapper .timebox {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
    }

    .timebox-wrapper .timebox > div:first-child {
      font-size: 3rem;
    }
    *[data-moved], *[data-cancel] {
      filter: opacity(.8);
    }
    .banner {
      transform: rotate(7deg);
    }

  </style>
</head>

<BaseLayout>
  <div class="relative isolate">
    <svg
      class="absolute inset-x-0 top-0 -z-10 h-[64rem] w-full stroke-gray-200 [mask-image:radial-gradient(32rem_32rem_at_center,white,transparent)]"
      aria-hidden="true">
      <defs>
        <pattern id="1f932ae7-37de-4c0a-a8b0-a6e3b4d44b84" width="200" height="200" x="50%" y="-1"
                 patternUnits="userSpaceOnUse">
          <path d="M.5 200V.5H200" fill="none"/>
        </pattern>
      </defs>
      <svg x="50%" y="-1" class="overflow-visible fill-gray-50">
        <path d="M-200 0h201v201h-201Z M600 0h201v201h-201Z M-400 600h201v201h-201Z M200 800h201v201h-201Z"
              stroke-width="0"/>
      </svg>
      <rect width="100%" height="100%" stroke-width="0" fill="url(#1f932ae7-37de-4c0a-a8b0-a6e3b4d44b84)"/>
    </svg>
    <div class="absolute left-1/2 right-0 top-0 -z-10 -ml-24 transform-gpu overflow-hidden blur-3xl lg:ml-24 xl:ml-48"
         aria-hidden="true">
      <div class="aspect-[801/1036] w-[50.0625rem] bg-gradient-to-tr from-[#eabf8f] to-[#842d44] opacity-30"
           style="clip-path: polygon(63.1% 29.5%, 100% 17.1%, 76.6% 3%, 48.4% 0%, 44.6% 4.7%, 54.5% 25.3%, 59.8% 49%, 55.2% 57.8%, 44.4% 57.2%, 27.8% 47.9%, 35.1% 81.5%, 0% 97.7%, 39.2% 100%, 35.2% 81.4%, 97.2% 52.8%, 63.1% 29.5%)"></div>
    </div>
    <div class="overflow-hidden">
      <div class="mx-auto max-w-7xl px-6 pb-32 pt-36 sm:pt-60 lg:px-8 lg:pt-32">
        <div class="mx-auto max-w-2xl gap-x-14 lg:mx-0 lg:flex lg:max-w-none lg:items-center">
          <div class="w-full max-w-xl lg:shrink-0 xl:max-w-2xl">
            <p class="text-base font-semibold leading-7 text-rose-800">{gruppe?.data?.name}</p>
            <h1 class="text-4xl font-bold tracking-tight text-gray-900 sm:text-6xl">{title}</h1>
            <p class="relative mt-6 text-lg leading-8 text-gray-600 sm:max-w-md lg:max-w-none">{description}</p>
            <script is:inline>
              document.addEventListener('DOMContentLoaded', () => {
                const date = new Date(document.querySelector('.timebox-wrapper').dataset.date);
                // create a function how to update the time every second
                const update = () => {
                  const now = new Date();
                  const diff = date - now;
                  const abgelaufen = diff < 0;
                  const tage = Math.floor(diff / (1000 * 60 * 60 * 24));
                  const stunden = Math.floor((diff / (1000 * 60 * 60)) % 24);
                  const minuten = Math.floor((diff / 1000 / 60) % 60);
                  const sekunden = Math.floor((diff / 1000) % 60);
                  if (abgelaufen) {
                    document.getElementById('wrapper').innerHTML = 'Schön wars, leider ist es schon vorbei! Unten findest du den Bericht und Bilder.';
                    return;
                  }
                  document.getElementById('tage').innerText = tage;
                  document.getElementById('stunden').innerText = stunden;
                  document.getElementById('minuten').innerText = minuten;
                  document.getElementById('sekunden').innerText = sekunden;
                }

                // update the time every second
                update();
                setInterval(update, 1000);
              });
            </script>
            <div class="timebox-wrapper relative mt-6 text-lg leading-8 text-gray-600 sm:max-w-md lg:max-w-none" id="wrapper" data-date={date}>
              {abgesagt && (
                <div class="absolute banner top-1/2 w-full text-center z-10 px-3.5 py-2.5 bg-rose-600 text-white rounded-full shadow-2xl transform">Abgesagt</div>
              )}
              {verschoben && (
                <div class="absolute banner top-1/2 w-full text-center z-10 px-3.5 py-2.5 bg-copper-400 text-white rounded-full shadow-2xl transform">Verschoben</div>
              )}
              <div class="overflow-hidden w-32 rounded-lg bg-slate-50 shadow">
                <div class="px-4 py-5 sm:p-6 timebox">
                  <div id="tage">0</div>
                  <div>Tage</div>
                </div>
              </div>
              <div class="overflow-hidden w-32 rounded-lg bg-slate-50 shadow">
                <div class="px-4 py-5 sm:p-6 timebox">
                  <div id="stunden">0</div>
                  <div>Stunden</div>
                </div>
              </div>
              <div class="overflow-hidden w-32 rounded-lg bg-slate-50 shadow">
                <div class="px-4 py-5 sm:p-6 timebox">
                  <div id="minuten">0</div>
                  <div>Minuten</div>
                </div>
              </div>
              <div class="overflow-hidden w-32 rounded-lg bg-slate-50 shadow">
                <div class="px-4 py-5 sm:p-6 timebox">
                  <div id="sekunden">0</div>
                  <div>Sekunden</div>
                </div>
              </div>
            </div>
          </div>
          <div class="mt-14 flex justify-end gap-8 sm:justify-start sm:pl-10 lg:pl-0">
            <div class="mr-auto w-full flex-none space-y-8 sm:mr-0 sm:pt-6 lg:pt-12">
              <div class="relative">
                <img src={heroImage} alt={title}   data-cancel={abgesagt} data-moved={verschoben}
                     class="aspect-[2/3] w-full rounded-xl bg-gray-900/5 object-cover shadow-lg">
                <div class="pointer-events-none absolute inset-0 rounded-xl ring-1 ring-inset ring-gray-900/10"></div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <div class="bg-rose-800 py-24 sm:py-32">
    <div class="mx-auto max-w-7xl px-6 lg:px-8">
      <dl class="grid grid-cols-1 gap-x-8 gap-y-16 text-center lg:grid-cols-2">
        <div class="mx-auto flex max-w-xs flex-col gap-y-4">
          <dt class="text-base leading-7 text-gray-200">Wann ist die Veranstaltung?</dt>
          <dd class="order-first text-3xl font-semibold tracking-tight text-white sm:text-5xl"><FormattedDate date={date}/></dd>
        </div>
        <div class="mx-auto flex max-w-xs flex-col gap-y-4">
          <dt class="text-base leading-7 text-gray-200">Wann geht es los?</dt>
          <dd class="order-first text-3xl font-semibold tracking-tight text-white sm:text-5xl"><FormattedTime date={date}/></dd>
        </div>
      </dl>
    </div>
  </div>

  <!-- Pricing -->
  <div class="bg-white py-8 sm:py-12">
    <div class="mx-auto max-w-7xl px-6 lg:px-8">
      <div class="mx-auto mt-16 max-w-2xl rounded-3xl ring-1 ring-gray-200 sm:mt-20 lg:mx-0 lg:flex lg:max-w-none">
        {
          (goody && goody.length > 0) ?
            (
              <div class="p-8 sm:p-10 lg:flex-auto">
                <div class="flex items-center gap-x-4">
                  <h4 class="flex-none text-sm font-semibold leading-6 text-rose-800">Es gibt während dem Event?</h4>
                  <div class="h-px flex-auto bg-gray-100"></div>
                </div>
                <ul role="list" class="mt-8 grid grid-cols-1 gap-4 text-sm leading-6 text-gray-600 sm:grid-cols-3 sm:gap-6">
                  { goody.map( goody =>
                    (<li class="flex gap-x-3">
                      <svg class="h-6 w-5 flex-none text-rose-600" viewBox="0 0 20 20" fill="currentColor" aria-hidden="true">
                        <path fill-rule="evenodd" d="M16.704 4.153a.75.75 0 01.143 1.052l-8 10.5a.75.75 0 01-1.127.075l-4.5-4.5a.75.75 0 011.06-1.06l3.894 3.893 7.48-9.817a.75.75 0 011.05-.143z" clip-rule="evenodd" />
                      </svg>
                      {goody}
                    </li>)
                  )}
                </ul>

              </div>
            ) : null
        }
        <div class={`-mt-2 p-2 lg:mt-0 lg:w-full lg:flex-shrink-0 ${(goody && goody.length >0 ) ? 'lg:max-w-md' : null}`}>
          <div class="rounded-2xl bg-gray-50 py-10 text-center ring-1 ring-inset h-full ring-gray-900/5 lg:flex lg:flex-col lg:justify-center lg:py-16">
            <div class="mx-auto max-w-xs px-8">
              <p class="text-base font-semibold text-gray-600">Eintrittspreis</p>
              <p class="mt-6 flex items-baseline justify-center gap-x-2">
                {

                  (price && price > 0) ? (
                    <span class="text-5xl font-bold tracking-tight text-gray-900">{readablePrice}€</span>
                    <span class="text-sm font-semibold leading-6 tracking-wide text-gray-600">EUR</span>
                  ) : (
                    <span class="text-5xl font-bold tracking-tight text-gray-900">Eintritt frei</span>
                  )}
              </p>
              <p class="mt-6 text-xs leading-5 text-gray-600">{priceDescription}</p>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  { (programm && programm.length > 0) ? (
    <div class="overflow-hidden bg-white py-24 sm:py-32">
      <div class="mx-auto max-w-7xl px-6 lg:px-8">
        <div class="mx-auto grid max-w-2xl grid-cols-1 gap-x-8 gap-y-16 sm:gap-y-20 lg:mx-0 lg:max-w-none lg:grid-cols-2">
          <div class="lg:ml-auto lg:pl-4 lg:pt-4">
            <div class="lg:max-w-lg">
              <h2 class="text-base font-semibold leading-7 text-rose-800">Programm</h2>
              <p class="mt-2 text-3xl font-bold tracking-tight text-gray-900 sm:text-4xl">Unser Programm</p>
              <dl class="mt-10 max-w-xl space-y-8 text-base leading-7 text-gray-600 lg:max-w-none">
                {programm.map(zeitpunkt =>
                  (<div class="relative">
                    <dt class="inline font-semibold text-gray-900">
                      {zeitpunkt.title}
                    </dt>
                    <dd class="inline"> {zeitpunkt.description} </dd>
                    <dd><FormattedTime date={zeitpunkt.time} /> - <FormattedTime date={zeitpunkt.endTime} /></dd>
                  </div>)
                )}
              </dl>
            </div>
          </div>
          <div class="flex items-start justify-end lg:order-first">
            <img src="/placeholder-time.svg" alt="Programm" class="w-[48rem] max-w-none rounded-xl shadow-xl ring-1 ring-gray-400/10 sm:w-[57rem]" width="2432" height="1442">
          </div>
        </div>
      </div>
    </div>
    ) : null}

    <div class="bg-white px-6 py-12 lg:px-8">
      <div class="mx-auto max-w-6xl text-base text-slate-700 md-content prose">
        <slot/>
      </div>
    </div>


  { (related_blog_ref && relatedBlog) ?
    (<div class="bg-white">
      <div class="mx-auto max-w-7xl py-24 sm:px-6 sm:py-32 lg:px-8">
        <div class="relative isolate overflow-hidden bg-gray-900 px-6 pt-16 shadow-2xl sm:rounded-3xl sm:px-16 md:pt-24 lg:flex lg:gap-x-20 lg:px-24 lg:pt-0">
          <svg viewBox="0 0 1024 1024" class="absolute left-1/2 top-1/2 -z-10 h-[64rem] w-[64rem] -translate-y-1/2 [mask-image:radial-gradient(closest-side,white,transparent)] sm:left-full sm:-ml-80 lg:left-1/2 lg:ml-0 lg:-translate-x-1/2 lg:translate-y-0" aria-hidden="true">
            <circle cx="512" cy="512" r="512" fill="url(#759c1415-0410-454c-8f7c-9a820de03641)" fill-opacity="0.7" />
            <defs>
              <radialGradient id="759c1415-0410-454c-8f7c-9a820de03641">
                <stop stop-color="#7775D6" />
                <stop offset="1" stop-color="#E935C1" />
              </radialGradient>
            </defs>
          </svg>
          <div class="mx-auto max-w-md text-center lg:mx-0 lg:flex-auto lg:py-32 lg:text-left">
            <h2 class="text-3xl font-bold tracking-tight text-white sm:text-4xl">{relatedBlog?.data?.title}</h2>
            <p class="mt-6 text-lg leading-8 text-gray-300">{relatedBlog?.data?.description}</p>
            <div class="mt-10 flex items-center justify-center gap-x-6 lg:justify-start">
              <a href={`neuigkeiten/${relatedBlog?.slug}`} class="rounded-md bg-white px-3.5 py-2.5 text-sm font-semibold text-gray-900 shadow-sm hover:bg-gray-100 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-white">Zum Bericht</a>
            </div>
          </div>
          <div class="relative mt-16 h-80 lg:mt-8">
            <img class="absolute left-0 top-0 w-[57rem] max-w-none rounded-md bg-white/5 ring-1 ring-white/10" src={relatedBlog?.data?.heroImage} alt={relatedBlog?.data?.title} width="1824" height="1080">
          </div>
        </div>
      </div>
    </div>) : null }
  {sponsoren && sponsoren.length > 0 ? (
    <div class="bg-white py-24 sm:py-32">
      <div class="mx-auto max-w-7xl px-6 lg:px-8">
        <h2 class="text-center text-lg font-semibold leading-8 text-gray-900">Unsere Sponsoren für diese Veranstaltung</h2>
        <div class="mx-auto mt-10 grid max-w-lg grid-cols-4 items-center gap-x-8 gap-y-10 sm:max-w-xl sm:grid-cols-4 sm:gap-x-10 lg:mx-0 lg:max-w-none lg:grid-cols-4">
          { sponsoren.map( sponsor =>
            (<img class="col-span-2 max-h-24 w-full object-contain lg:col-span-1" src={`/sponsoren/${sponsor}`} alt={`Sponsor für ${title}`} />)
          )}

        </div>
      </div>
    </div>) : null }


</BaseLayout>
</html>
